帳戶是透過業界標準的 OAuth 2.0 授權碼流程連結。
代理程式適用的 OAuth 2.1 和 PKCE
對於無狀態 AI 代理程式和多模態管道,建議強制執行 OAuth 2.1。
- PKCE (用於程式碼交換的金鑰證明):必須用於保護授權碼流程,防止攔截攻擊。
- 沒有隱含流程:隱含流程會在網址中公開存取權杖, 這會對代理程式環境造成安全風險。
您的服務必須支援符合 OAuth 2.0/2.1 規範的授權和權杖交換端點。
Create the project
To create your project to use account linking:
- Go to the Google API Console.
- Click Create project.
- Enter a name or accept the generated suggestion.
- Confirm or edit any remaining fields.
- Click Create.
To view your project ID:
- Go to the Google API Console.
- Find your project in the table on the landing page. The project ID appears in the ID column.
Configure your OAuth Consent Screen
The Google Account Linking process includes a consent screen which tells users the application requesting access to their data, what kind of data they are asking for and the terms that apply. You will need to configure your OAuth consent screen before generating a Google API client ID.
- Open the OAuth consent screen page of the Google APIs console.
- If prompted, select the project you just created.
On the "OAuth consent screen" page, fill out the form and click the “Save” button.
Application name: The name of the application asking for consent. The name should accurately reflect your application and be consistent with the application name users see elsewhere. The application name will be shown on the Account Linking consent screen.
Application logo: An image on the consent screen that will help users recognize your app. The logo is shown on Account linking consent screen and on account settings
Support email: For users to contact you with questions about their consent.
Scopes for Google APIs: Scopes allow your application to access your user's private Google data. For the Google Account Linking use case, default scope (email, profile, openid) is sufficient, you don’t need to add any sensitive scopes. It is generally a best practice to request scopes incrementally, at the time access is required, rather than up front. Learn more.
Authorized domains: To protect you and your users, Google only allows applications that authenticate using OAuth to use Authorized Domains. Your applications' links must be hosted on Authorized Domains. Learn more.
Application Homepage link: Home page for your application. Must be hosted on an Authorized Domain.
Application Privacy Policy link: Shown on Google Account Linking consent screen. Must be hosted on an Authorized Domain.
Application Terms of Service link (Optional): Must be hosted on an Authorized Domain.
Figure 1. Google Account Linking Consent Screen for a fictitious Application, Tunery
Check "Verification Status", if your application needs verification then click the "Submit For Verification" button to submit your application for verification. Refer to OAuth verification requirements for details.
導入 OAuth 伺服器
OAuth 2.0 伺服器實作的授權碼流程包含兩個端點,您的服務會透過 HTTPS 提供這些端點。第一個端點是授權端點,負責尋找或取得使用者同意聲明,允許存取資料。授權端點會向尚未登入的使用者顯示登入 UI,並記錄他們對所要求存取的同意聲明。第二個端點是權杖交換端點,用於取得加密字串 (稱為權杖),授權使用者存取您的服務。
當 Google 應用程式需要呼叫您服務的 API 時,Google 會一併使用這些端點,向使用者取得代表他們呼叫這些 API 的權限。
Google 帳戶連結:OAuth 授權碼流程
下方的序列圖詳細說明使用者、Google 和服務端點之間的互動。
角色與職責
下表定義 Google 帳戶連結 (GAL) OAuth 流程中參與者的角色和職責。請注意,在 GAL 中,Google 是 OAuth 用戶端,而您的服務是身分/服務供應商。
| 執行者 / 元件 | GAL 角色 | 職責 |
|---|---|---|
| Google 應用程式 / 伺服器 | OAuth 用戶端 | 啟動流程、接收授權碼、將授權碼換成權杖,並安全地儲存權杖,以便存取服務的 API。 |
| 您的授權端點 | 授權伺服器 | 驗證使用者身分,並徵得同意,允許 Google 存取使用者資料。 |
| 您的權杖交換端點 | 授權伺服器 | 驗證授權碼和更新權杖,並將存取權杖核發給 Google 伺服器。 |
| Google 重新導向 URI | 回呼端點 | 從授權服務接收使用者重新導向,其中包含 code 和 state 值。 |
Google 啟動的 OAuth 2.0 授權碼流程工作階段會依下列流程進行:
- Google 會在使用者瀏覽器中開啟授權端點。如果使用者在僅支援語音的裝置上啟動動作流程,Google 會將執行作業轉移至手機。
- 使用者登入 (如果尚未登入),並授權 Google 透過您的 API 存取資料 (如果尚未授權)。
- 您的服務會建立授權碼,並傳回給 Google。如要這麼做,請將使用者的瀏覽器重新導向回 Google,並在要求中附加授權碼。
- Google 會將授權碼傳送至權杖交換端點,該端點會驗證授權碼的真實性,並傳回存取權杖和更新權杖。存取權杖是短期權杖,服務會接受這類權杖做為存取 API 的憑證。更新權杖是長期有效的權杖,Google 可以儲存並在存取權杖過期時使用,以取得新的存取權杖。
- 使用者完成帳戶連結流程後,Google 傳送的每個後續要求都會包含存取權杖。
導入作業參考資料
請按照下列步驟導入授權碼流程。
步驟 1:處理授權要求
Google 啟動帳戶連結程序時,會將使用者重新導向至授權端點。如需詳細的通訊協定合約和參數規定,請參閱「授權端點」。
如要處理要求,請執行下列動作:
驗證要求:
- 確認
client_id與指派給 Google 的用戶端 ID 相符。 - 確認
redirect_uri與預期的 Google 重新導向網址相符:none https://oauth-redirect.googleusercontent.com/r/YOUR_PROJECT_ID https://oauth-redirect-sandbox.googleusercontent.com/r/YOUR_PROJECT_ID - 確認
response_type為code。
- 確認
驗證使用者:
- 確認使用者是否已登入您的服務。
- 如果使用者未登入,請提示他們完成登入或註冊流程。
產生授權碼:
- 建立與使用者和用戶端相關聯的專屬授權碼,且該授權碼無法猜出。
- 將驗證碼的有效期限設為約 10 分鐘。
重新導向回 Google:
- 將瀏覽器重新導向至
redirect_uri中提供的網址。 - 附加下列查詢參數:
code:您產生的授權碼。state:從 Google 收到的未修改狀態值。
- 將瀏覽器重新導向至
步驟 2:處理權杖交換要求
權杖交換端點會處理兩類要求:將代碼換成權杖,以及更新過期的存取權杖。如需詳細的通訊協定合約和參數規定,請參閱「權杖交換端點」。
A. 交換授權碼以取得權杖
Google 收到授權碼後,會呼叫權杖交換端點 (POST) 來擷取權杖。
驗證要求:
- 驗證「
client_id」和「client_secret」。 - 確認授權碼有效且未過期。
- 確認
redirect_uri與步驟 1 中使用的值相符。 - 如果驗證失敗,請傳回含有
{"error": "invalid_grant"}的 HTTP400 Bad Request。
- 驗證「
核發權杖:
- 產生長期
refresh_token和短期access_token(通常為 1 小時)。 - 傳回 HTTP
200 OK,其中包含標準 JSON 權杖回應。
- 產生長期
B. 重新整理存取權杖
存取權杖到期時,Google 會使用更新權杖要求新的存取權杖。
驗證要求:
- 驗證「
client_id」、「client_secret」和「refresh_token」。 - 如果驗證失敗,請傳回含有
{"error": "invalid_grant"}的 HTTP400 Bad Request。
- 驗證「
核發新的存取權杖:
- 產生新的短期
access_token。 - 傳回含有 JSON 權杖回應的 HTTP
200 OK(可選擇是否包含新的更新權杖)。
- 產生新的短期
Handle userinfo requests
The userinfo endpoint is an OAuth 2.0 protected resource that return claims about the linked user. Implementing and hosting the userinfo endpoint is optional, except for the following use cases:
- Linked Account Sign-In with Google One Tap.
- Frictionless subscription on AndroidTV.
After the access token has been successfully retrieved from your token endpoint, Google sends a request to your userinfo endpoint to retrieve basic profile information about the linked user.
| userinfo endpoint request headers | |
|---|---|
Authorization header |
The access token of type Bearer. |
For example, if your userinfo endpoint is available at
https://myservice.example.com/userinfo, a request might look like the following:
GET /userinfo HTTP/1.1 Host: myservice.example.com Authorization: Bearer ACCESS_TOKEN
For your userinfo endpoint to handle requests, do the following steps:
- Extract access token from the Authorization header and return information for the user associated with the access token.
- If the access token is invalid, return an HTTP 401 Unauthorized error with using the
WWW-AuthenticateResponse Header. Below is an example of a userinfo error response: If a 401 Unauthorized, or any other unsuccessful error response is returned during the linking process, the error will be non-recoverable, the retrieved token will be discarded and the user will have to initiate the linking process again.HTTP/1.1 401 Unauthorized WWW-Authenticate: error="invalid_token", error_description="The Access Token expired"
If the access token is valid, return and HTTP 200 response with the following JSON object in the body of the HTTPS response:
If your userinfo endpoint returns an HTTP 200 success response, the retrieved token and claims are registered against the user's Google account.{ "sub": "USER_UUID", "email": "EMAIL_ADDRESS", "given_name": "FIRST_NAME", "family_name": "LAST_NAME", "name": "FULL_NAME", "picture": "PROFILE_PICTURE", }userinfo endpoint response subA unique ID that identifies the user in your system. emailEmail address of the user. given_nameOptional: First name of the user. family_nameOptional: Last name of the user. nameOptional: Full name of the user. pictureOptional: Profile picture of the user.
驗證實作
You can validate your implementation by using the OAuth 2.0 Playground tool.
In the tool, do the following steps:
- Click Configuration to open the OAuth 2.0 Configuration window.
- In the OAuth flow field, select Client-side.
- In the OAuth Endpoints field, select Custom.
- Specify your OAuth 2.0 endpoint and the client ID you assigned to Google in the corresponding fields.
- In the Step 1 section, don't select any Google scopes. Instead, leave this field blank or type a scope valid for your server (or an arbitrary string if you don't use OAuth scopes). When you're done, click Authorize APIs.
- In the Step 2 and Step 3 sections, go through the OAuth 2.0 flow and verify that each step works as intended.
You can validate your implementation by using the Google Account Linking Demo tool.
In the tool, do the following steps:
- Click the Sign in with Google button.
- Choose the account you'd like to link.
- Enter the service ID.
- Optionally enter one or more scopes that you will request access for.
- Click Start Demo.
- When prompted, confirm that you may consent and deny the linking request.
- Confirm that you are redirected to your platform.